/**
 * 
 */
package kfmes.jateon.swing;

import javax.swing.ImageIcon;
import javax.swing.JLabel;

import kfmes.natelib.NateonMessenger;
import kfmes.natelib.entity.NateFriend;
import kfmes.natelib.entity.UserStatus;

/**
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: OwnerRenderer.java,v 1.13 2007/11/19 10:13:34 kfmes Exp $
 */
public class OwnerRenderer{
	
	private JLabel ownStatus;
	private NateonMessenger nate = null;
	private MainFrame mainfrm = null;
	private NateFriend owner = null;
	private ImageIcon imageOnline;
	private ImageIcon imageOffline;
	private ImageIcon imageBusy;
	private ImageIcon imageAway;
	
	
	public void setOwnerRenderer(MainFrame mainframe){
		
		this.mainfrm = mainframe;
		this.nate = mainframe.getMessenger();
		this.owner = nate.getOwner();
		
		imageOnline = UIToolkit.getImage("icon/on.gif");
		imageOffline = UIToolkit.getImage("icon/off.gif");
		imageBusy = UIToolkit.getImage("icon/busy.gif");
		imageAway = UIToolkit.getImage("icon/away.gif");
		ownStatus = new JLabel();
		ownStatus.setOpaque( true );
						
	}
	
	
	public JLabel getLabel(){
		this.owner = nate.getOwner();
		String status = owner.getStatus();
		//MsgUtil.println("owner status : " + status);

		
		if(status ==null || status.equals(UserStatus.Offline)){
			ownStatus.setText("로그인 되지 않음");
			//MsgUtil.println("asdf");
		}
		/*
		else if( status.equals(UserStatus.Online) )
		{
			//status = "";
			ownStatus.setIcon( imageOnline );
		}*/
		else
		{
			ownStatus.setIcon( imageOnline );

			if( status.equals(UserStatus.Away) ||
				status.equals(UserStatus.Meeting) )
			{
				ownStatus.setIcon( imageAway );
			}
			else
			if( status.equals(UserStatus.Busy) ||
				status.equals(UserStatus.Phone))
			{
				ownStatus.setIcon( imageBusy );
			}
			else
			if( status.equals(UserStatus.Offline) ||
				status.equals(UserStatus.Invisible) )
			{
				ownStatus.setIcon( imageOffline );
			}
			ownStatus.setText( owner.getNickName().replaceAll("%20", " ").replaceAll("%25", "%") +
					"\r\n(" + owner.getFormattedStatus() + ")");
			//status = " (" + owner.getFormattedStatus() + ")";
		}

		
		return ownStatus;
	}
	

}