/**
 * 
 */
package kfmes.jateon.swing.dialog;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.WindowConstants;

import kfmes.jateon.swing.MainFrame;

/**
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: AddFriendDialog.java,v 1.7 2007/11/19 10:13:33 kfmes Exp $
 */
public class AddFriendDialog extends AbstractDialog implements ActionListener, FocusListener {
	/**
	 * 
	 */
	private static final long serialVersionUID = -4633093196813973407L;
	private JLabel lbl_id;
	private JLabel lbl_reqmsg;

	private JTextArea txt_reqMsg;
	private JScrollPane jsp;
	private JButton btn_cancel;
	private JButton btn_OK;
	private JTextField txt_nateID;
	private MainFrame mainfrm = null;
	
	
	/**
	 * @param owner
	 * @param title
	 * @param modal
	 */
	public AddFriendDialog(MainFrame owner, String title, boolean modal) {
		super(owner, title, modal);
		this.mainfrm = owner;
		init();
		//this.setVisible(true);
		// TODO 자동 생성된 생성자 스텁
	}
	
	private void init() {
		try {
			setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
			getContentPane().setLayout(null);
		
			lbl_id = new JLabel();
			getContentPane().add(lbl_id);
			lbl_id.setText("아이디");
			lbl_id.setBounds(14, 7, 49, 21);
		
		
			lbl_reqmsg = new JLabel();
			getContentPane().add(lbl_reqmsg);
			lbl_reqmsg.setText("요청메시지");
			lbl_reqmsg.setBounds(7, 35, 70, 28);
		
		
			txt_nateID = new JTextField();
			getContentPane().add(txt_nateID);
			txt_nateID.setBounds(77, 7, 203, 21);
		
		
			btn_OK = new JButton();
			getContentPane().add(btn_OK);
			btn_OK.setText("확인");
			btn_OK.setBounds(147, 98, 63, 28);
			btn_OK.addActionListener(this);
		
			btn_cancel = new JButton();
			getContentPane().add(btn_cancel);
			btn_cancel.setText("취소");
			btn_cancel.setBounds(217, 98, 63, 28);
			btn_cancel.addActionListener(this);
		
			jsp = new JScrollPane();
			getContentPane().add(jsp);
			jsp.setBounds(77, 35, 203, 56);
			{
				txt_reqMsg = new JTextArea();
				//getContentPane().add(txt_reqMsg);
				txt_reqMsg.setText("친구 추가 합니당~");
				jsp.setViewportView(txt_reqMsg);
				//txt_reqMsg.setBounds(14, 98, 203, 63);
				//txt_reqMsg.setBorder(BorderFactory.createEtchedBorder(BevelBorder.LOWERED));
				txt_reqMsg.setLineWrap(true);
				txt_reqMsg.addFocusListener(this);
				
				//txt_reqMsg.setBounds(77, 35, 203, 56);
				//txt_reqMsg.setSize(200, 53);
				

			}
			//jsp.set

			//pack();
			this.setSize(295, 160);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void actionPerformed(ActionEvent e) {
		Object oe= e.getSource();

		if(oe.equals(btn_OK)){
			mainfrm.getMessenger().getNS().requestAdd(
					txt_nateID.getText(),txt_reqMsg.getText().replaceAll("\n", "%0D%0A"));
			this.dispose();
			
		}
		else if(oe.equals(btn_cancel)){
			this.dispose();			
		}
		
	}

	public void focusGained(FocusEvent e) {
		txt_reqMsg.setSelectionStart(0);
		txt_reqMsg.setSelectionEnd(txt_reqMsg.getText().length());		
	}

	public void focusLost(FocusEvent e) {
		// TODO 자동 생성된 메소드 스텁
		
	}

	/**
	 * @param args
	 */


}
