/**
 * 
 */
package kfmes.jateon.swing.dialog;

import java.awt.FlowLayout;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
/**
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: infoLicense.java,v 1.13 2007/11/19 10:13:32 kfmes Exp $
 */
public class infoLicense extends AbstractDialog {

	public infoLicense(Frame owner, String title, boolean modal) {
		super(owner, title, modal);
		
		this.setSize(300, 350);
		this.setLocation( 
			owner.getLocation().x + (owner.getWidth() - getWidth()) / 2,
			owner.getLocation().y + (owner.getHeight() - getHeight()) / 2);		
		this.setTitle("라이센스");
				
		
		/*
		JScrollPane jsp = new JScrollPane();
		JTextArea jtxt = new JTextArea();
		jsp.add(jtxt);
		this.add(jsp);
		this.setLayout(new BorderLayout());
		*/
		JPanel panel = (JPanel)getContentPane();

		JPanel mainPanel = new JPanel();
		
		BoxLayout box = new BoxLayout(mainPanel, BoxLayout.Y_AXIS);
		mainPanel.setLayout( box );
		
		JScrollPane jsp = new JScrollPane();
		//String txt = "\tJaTeOn 라이센스\n\n본 프로그램의 전체 또는 일부를 제 3자에게 재배포하지 마십시오.\n\n위 사항을 어길시 프로그램 이용에 제한이 있을 수 있습니다.\n\n본 프로그램을 사용하여 발생하는 불이익 등에 대해서는 제작자는 책임을 지지 않음을 알려드립니다.";
		String txt = "\tJaTeOn 라이센스\n\njateon 은 공식 포럼에서 구하실 수 있습니다.\n\n본 프로그램을 사용하여 발생하는 불이익 등에 대해서는 제작자는 책임을 지지 않음을 알려드립니다.\n\n영리목적으로 사용 하시면 안됩니다\n  (광고나 스펨 기타 등등)\n\n별도의 공지 없이 jateon 이용이 중지될수도 있습니다.";
		
		JTextArea jtxt = new JTextArea(txt);
		jtxt.setLineWrap(true);
		jsp.setViewportView(jtxt);
		jtxt.setEditable(false);
		
		//jsp.add(jtxt);
		//this.add(jsp);
				
		mainPanel.add( jsp );
		//mainPanel.add( l1 );
		//mainPanel.add( l2 );

		JPanel bottomPanel = new JPanel(new FlowLayout());
		JButton closeButton = new JButton("닫기");
		closeButton.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent e )
			{
				dispose();
			}
		});
		
		bottomPanel.add( closeButton );

		panel.add( mainPanel, "Center" );
		panel.add( bottomPanel, "South" );
		this.setVisible(true);
	}

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	
	public infoLicense() {
		this(null, "license", false);
		
	}
	
	
	public static void main(String args[]){
		new infoLicense();
	}

}