/**
 * 
 */
package kfmes.jateon.swt;


import java.util.ArrayList;

import kfmes.jateon.swt.dialog.WebBrowser;
import kfmes.natelib.NateonMessenger;
import kfmes.natelib.entity.NateFriend;
import kfmes.natelib.entity.NateGroup;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.ToolBar;
import org.eclipse.swt.widgets.ToolItem;

/**
 * 메뉴 바 - 자테온 밑부분
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: MenuBar.java,v 1.35 2007/11/19 10:13:31 kfmes Exp $
 */
final public class MenuBar {

	protected MainFrame main = null;
	protected ActionGroup action = null;
	private Menu menu_SubChangeStatus = null;
	//private Menu submenu = null;
	private Menu menu_mvGrp =null;
	private Listener listener = new Listener();  //  @jve:decl-index=0:
	private MenuItem m_login;
	private MenuItem m_logout;
	private MenuItem m_debug;
	private MenuItem m_debug1; 
	private MenuItem m_Exit;
	
	private MenuItem m_GroupRename;
	private MenuItem m_GroupDelete;
	
	private MenuItem m_info;
	private MenuItem m_sendMsg;
	private MenuItem m_reqChat;
	private MenuItem m_sendSMS;
	private MenuItem m_buddyDbg;
	private MenuItem m_removeBuddy;
	private MenuItem m_visitMinihp;
	private MenuItem m_helpmenu;
	private MenuItem m_mvGrp;
	
	private MenuItem menu_ClearLoginInfo;
	private MenuItem m_adsetting;

	private ToolItem btn_Msg;
	private ToolItem btn_Chat;
	private ToolItem btn_SMS;
	private ToolItem btn_addBuddy;
	private ToolItem btn_addGroup;
	
	private ToolItem btn_filemon;
	private MenuItem m_ChangeNick;
	private MenuItem m_ChangeStatus;
	private MenuItem m_block;
	//private MenuItem m_buddyRemove;

	/*
	MenuItem menu_Action = null;
	MenuItem menu_Setting = null;
	MenuItem menu_Help = null;
	MenuItem m_License = null;
	*/
	public MenuBar(MainFrame main, ActionGroup action) {
		this.main = main;
		this.action = action;
	}
	
	
	protected ToolBar createToolBar(Shell shell) {
		
		ToolBar toolBar;
		GridData gridData = new GridData();
		gridData.grabExcessVerticalSpace = false;
		gridData.verticalAlignment = GridData.END;
		gridData.grabExcessHorizontalSpace = true;
		gridData.horizontalAlignment = GridData.FILL;
		//gridData.heightHint = 30;
		//toolBar = new ToolBar(shell, SWT.NONE);
		toolBar = new ToolBar(shell, SWT.FLAT );
		toolBar.setLayoutData(gridData);
		btn_Msg = new ToolItem(toolBar, SWT.PUSH );
		btn_Msg.setWidth(40);
		btn_Msg.setText("쪽지");
		btn_Chat = new ToolItem(toolBar, SWT.PUSH);
		btn_Chat.setText("대화");
		btn_SMS = new ToolItem(toolBar, SWT.PUSH);
		btn_SMS.setText("문자");
		btn_addBuddy = new ToolItem(toolBar, SWT.PUSH);
		btn_addBuddy.setText("친구추가");
		btn_addGroup = new ToolItem(toolBar, SWT.PUSH);
		btn_addGroup.setText("그룹추가");
		btn_filemon = new ToolItem(toolBar, SWT.PUSH);
		btn_filemon.setText("파일전송");
		btn_filemon.setToolTipText("파일전송 모니터를 보여줍니다");
		addToolBarListener(toolBar);
		return toolBar;
	}
	
	
	public Menu getMenuBar(){
		Menu menuBar = new Menu(main.shell, SWT.BAR);
		
		MenuItem menu_File = new MenuItem(menuBar, SWT.CASCADE);
		menu_File.setText("파일(&F)");
		
		
		
		MenuItem menu_Action = new MenuItem(menuBar, SWT.CASCADE);
		menu_Action.setText("동작(&A)");
		//menuAction.setAccelerator('A');
		MenuItem menu_Setting = new MenuItem(menuBar, SWT.CASCADE);
		menu_Setting.setText("설정(&S)");
		
		MenuItem menu_Help = new MenuItem(menuBar, SWT.CASCADE);
		menu_Help.setText("도움말(&H)");
		
		// 메뉴 파일
		Menu menu_SubFile = new Menu(menu_File);
		m_login = new MenuItem(menu_SubFile, SWT.PUSH);
		m_login.setText("로그인");
				
		m_logout = new MenuItem(menu_SubFile, SWT.PUSH);
		m_logout.setText("로그아웃");
		new MenuItem(menu_SubFile, SWT.SEPARATOR);
		if(NateonMessenger.isDebugMode){
			m_debug = new MenuItem(menu_SubFile, SWT.PUSH);
			m_debug.setText("디버깅 정보");
			m_debug1 = new MenuItem(menu_SubFile, SWT.PUSH);
			m_debug1.setText("Testing1");
		}
		
		menu_ClearLoginInfo = new MenuItem(menu_SubFile, SWT.PUSH);
		menu_ClearLoginInfo.setText("설정 지우기");
		
		
		new MenuItem(menu_SubFile, SWT.SEPARATOR);
		m_Exit = new MenuItem(menu_SubFile, SWT.PUSH);
		m_Exit.setText("나가기(&X)");
		
		menu_File.setMenu(menu_SubFile);
		
		/* 메뉴 동작 */
		Menu menu_SubAction = new Menu(main.shell,SWT.DROP_DOWN);
		MenuItem m_act_msg = new MenuItem(menu_SubAction, SWT.PUSH);
		m_act_msg.setText("쪽지 보내기");
		
		MenuItem m_act_chat = new MenuItem(menu_SubAction, SWT.PUSH);
		m_act_chat.setText("대화 걸기");
		
		MenuItem m_act_sms = new MenuItem(menu_SubAction, SWT.PUSH);
		m_act_sms.setText("문자 보내기");
		
		
		
		menu_Action.setMenu(menu_SubAction);
		
		/* 메뉴 도움말 */
		Menu menu_SubHelp = new Menu(menu_Help);
		MenuItem m_visitForum = new MenuItem(menu_SubHelp, SWT.PUSH);
		m_visitForum.setText("자테온 포럼 방문하기");
		MenuItem m_visitBlog = new MenuItem(menu_SubHelp, SWT.PUSH);
		m_visitBlog.setText("개발자 블로그 방문하기");
		m_helpmenu = new MenuItem(menu_SubHelp, SWT.PUSH);
		m_helpmenu.setText("도움말");
				
		
		
		new MenuItem(menu_SubHelp, SWT.SEPARATOR);
		
		
		
		MenuItem m_License = new MenuItem(menu_SubHelp, SWT.PUSH);
		m_License.setText("라이센스");
		MenuItem m_ChkNewVersion = new MenuItem(menu_SubHelp, SWT.PUSH);
		m_ChkNewVersion.setText("최신버전확인");
		MenuItem m_About = new MenuItem(menu_SubHelp, SWT.PUSH);
		m_About.setText("JaTeOn 정보");
		menu_Help.setMenu(menu_SubHelp);
		
		
		/* 메뉴 설정 */		
		
		Menu menu_SubSetting = new Menu(menu_Setting);
		m_ChangeNick = new MenuItem(menu_SubSetting, SWT.PUSH);
		m_ChangeNick.setText("대화명 설정");
		m_ChangeStatus = new MenuItem(menu_SubSetting, SWT.CASCADE);
		m_ChangeStatus.setText("상태 변경");
		m_adsetting = new MenuItem(menu_SubSetting, SWT.PUSH);
		m_adsetting.setText("상세 설정");
		
		
		
		//TODO: 상태 변경 메뉴를 얻어오는 방식으로 바꿔야함
		//menu_SubChangeStatus = getStatusChangeMenu(menu_SubSetting);
		
		
		menu_SubChangeStatus = new Menu(m_ChangeStatus);
		
		//////////////////////////////// begin
		
		MenuItem m_Status[] = new MenuItem[6];
	//	String statusString[] = { "Online", "Away", "Busy", "Phone", "Meeting", "Invisible","Offline" };
		String statusText[] = { "온라인", "자리비움", "다른용무중", "통화중", "회의중", "오프라인으로 표시" };

		for(int i=0;i<6;i++){
			m_Status[i] = new MenuItem(menu_SubChangeStatus, SWT.PUSH);//  "온라인");
			m_Status[i].setText(statusText[i]);
		}
		
		m_ChangeStatus.setMenu(menu_SubChangeStatus);
		
		menu_Setting.setMenu(menu_SubSetting);
		
		
		////////////////////////////////end 
		
	
		addMenuListener(menuBar);			
		
		return menuBar;
	}
	
	/* FIXME: 이부분을 구현 해야함
	protected Menu getStatusChangeMenu(Menu parent){
		
	}
	*/
	
	
	
	public Menu getDefaultPopup(Menu menu){
		if(menu==null)
			menu = new Menu(main.shell, SWT.POP_UP);
		String txt[] = { "이름으로 보기" , "대화명으로 보기" , "아이디로 보기", "이름+아이디로 보기" , "이름+대화명으로 보기"};
		
		
		
		for(int i=0;i<txt.length;i++){
			MenuItem foo =new MenuItem(menu, SWT.RADIO);
			foo.setText(txt[i]);	
			if(main.getBuddyTree().getBuddyView()==i)
				foo.setSelection(true);
			
		}
	
		new MenuItem(menu, SWT.SEPARATOR);
		{
		MenuItem foo = new MenuItem(menu,  SWT.CHECK);
		foo.setText("오프라인 사용자 보기");
		foo.setSelection(main.getBuddyTree().getOffView());
		}
		{
		MenuItem foo = new MenuItem(menu, SWT.PUSH );
		foo.setText("목록 새로고침");
		}
		addMenuListener(menu);
		
		/*MenuItem off

		mViewMode[0] = new JRadioButtonMenuItem("이름으로 보기");
		mViewMode[1] = new JRadioButtonMenuItem("대화명으로 보기");
		mViewMode[2] = new JRadioButtonMenuItem("아이디로 보기");
		mViewMode[3] = new JRadioButtonMenuItem("이름+아이디로 보기");
		mViewMode[4] = new JRadioButtonMenuItem("이름+대화명으로 보기");
		*/
		menu.setVisible(true);
		return menu;		
	}
	public Menu getGroupPopup(NateGroup group) {
		Menu menu = new Menu(main.shell, SWT.POP_UP);
		m_GroupRename = new MenuItem(menu, SWT.PUSH);
		m_GroupDelete = new MenuItem(menu, SWT.PUSH);
		m_GroupRename.setText("그룹 이름 변경");
		m_GroupDelete.setText("그룹 지우기");
		new MenuItem(menu, SWT.SEPARATOR);
		
		m_GroupRename.setData(group);
		m_GroupDelete.setData(group);
		menu = getDefaultPopup(menu);
		return menu;		
	}
	
	public Menu getPopup(final NateFriend friend) {
		
		Menu menu = new Menu(main.shell, SWT.POP_UP);
		m_info = new MenuItem(menu,SWT.PUSH);
		new MenuItem(menu,SWT.SEPARATOR);
		m_sendMsg = new MenuItem(menu,SWT.PUSH);
		m_reqChat = new MenuItem(menu,SWT.PUSH);
		m_sendSMS = new MenuItem(menu,SWT.PUSH);
		
		
		m_info.setText(friend.getNameID());
		m_sendMsg.setText("쪽지 보내기(&Z)");
		m_reqChat.setText("대화 걸기(&A)");
		m_sendSMS.setText("문자 보내기(&S)");
		if(main.getMessenger().isDebugMode){
			m_buddyDbg = new MenuItem(menu, SWT.PUSH);
			m_buddyDbg.setText("Debuging");
		}
		
		m_visitMinihp = new MenuItem(menu, SWT.PUSH);
		m_visitMinihp.setText("미니홈피방문");
		m_visitMinihp.setData(friend.getCyworldNum());
		if(friend.getCyworldNum().equals("%00"))
			m_visitMinihp.setEnabled(false);
		m_block = new MenuItem(menu, SWT.PUSH);
		m_block.setText( friend.isBlocked() ? "차단 해제" : "친구 차단");
		m_block.setData(friend);
		m_removeBuddy = new MenuItem(menu, SWT.PUSH);
		m_removeBuddy.setData(friend);
		m_removeBuddy.setText("친구 삭제");
		
				
		m_mvGrp = new MenuItem(menu, SWT.CASCADE);
		menu_mvGrp = new Menu(m_mvGrp);
		m_mvGrp.setText("그룹 이동");
		m_mvGrp.setMenu(menu_mvGrp);
				
		ArrayList<NateGroup> glst = main.getMessenger().getBuddyGroup().getList();
		
		for(int i =0 ;i<glst.size()-1;i++){
			final NateGroup g = glst.get(i);
			
			if(g == friend.getGroup())
				continue;
			
			MenuItem m = new MenuItem(menu_mvGrp, SWT.PUSH);
			m.setText(g.getName() );
			
			m.addSelectionListener(new SelectionAdapter(){
				public void widgetSelected(SelectionEvent e) {
					action.actionMoveGroup(friend, g.getNumber());					
				}
				
			});
			
		}
		
		
		
		
		
			
		
		
		menu.setDefaultItem(m_info);
		
		addMenuListener(menu);
		/*
		 *  쪽지
		 *  대화
		 *  문자
		 */
		menu.setVisible(true);
		return menu;
	};
	
	
	
	
	public void setDblClickDefaultAction() {
		boolean flag = (main.getDblClickDefaultAction()==MainFrame.DefaultActionMsg) ? true : false;
		/* XXX: SWT 
		mSetDefaultMsg.setSelected( flag ? true: false);
		mSetDefaultChat.setSelected( flag ? false: true);
		*/
	}
	
	
	
	
	
	
	private void addToolBarListener(ToolBar tool){
		ToolItem t[] = tool.getItems();				
		for(int i=0;i<t.length;i++){			
			t[i].addSelectionListener(listener);
		}
	}


	private void addMenuListener(Menu menu){
		MenuItem t[] = menu.getItems();
				
		for(int i=0;i<t.length;i++){
			Menu m = t[i].getMenu();
			if(m!=null)
				addMenuListener(m);
			
			t[i].addSelectionListener(listener);
		}
	}
	
	/**
	 * 로그인/로그아웃 상태가 바뀌었을 때 변경되야 할 UI 처리를 해준다.
	 */
	public void setOnline( boolean isLogin )
	{
		m_login.setEnabled(!isLogin);
		m_logout.setEnabled(isLogin);
		
		m_ChangeNick.setEnabled(isLogin);
		m_ChangeStatus.setEnabled(isLogin);
		
		
		for(MenuItem item : menu_SubChangeStatus.getItems())
			item.setEnabled(isLogin);
		
		
		btn_Msg.setEnabled(isLogin);
		btn_Chat.setEnabled(isLogin);
		btn_SMS.setEnabled(isLogin);
		btn_addBuddy.setEnabled(isLogin);
		btn_filemon.setEnabled(isLogin);
		btn_addGroup.setEnabled(isLogin);
		if(main.tray!=null)
			main.tray.setOnline(isLogin);
	}


	private class Listener implements SelectionListener{



		public void widgetSelected(SelectionEvent e) {
		
			
			if (e.getSource() instanceof MenuItem) {
				MenuItem m = (MenuItem) e.getSource();
				String c = m.getText();
				
				if(m==m_login) // 로그인
					action.actionLogin();
				else if(m==m_logout) // 로그아웃
					action.actionLogout();
				else if(m==m_debug) // 디버깅 정보
					action.actionDebugInfo();
				else if(m==m_debug1) // 테스팅1
					action.actionWhoAddedMe(new NateFriend("adsf"));
				else if(m==m_Exit) // 나가기
					action.actionQuit();
				else if(m==menu_ClearLoginInfo) // 설정 지우기
					action.actionClearLoginInfo();
				
				else if(c.equals("쪽지 보내기"))
					action.actionSendIMsg(null);
				else if(c.equals("대화 걸기"))
					action.actionReqChat(null);
				else if(c.equals("문자 보내기"))
					action.actionSendSMS();
				
				else if(c.equals("온라인"))
					action.actionSetStatusOnline();
				else if(c.equals("자리비움"))
					action.actionSetStatusAway();
				else if(c.equals("다른용무중"))
					action.actionSetStatusBusy();
				else if(c.equals("통화중"))
					action.actionSetStatusPhone();
				else if(c.equals("회의중"))
					action.actionSetStatusMeeting();
				else if(c.equals("오프라인으로 표시"))
					action.actionSetStatusInvisible();
				
				else if(m==m_ChangeNick) // 대화명 설정
					action.actionChangeNick();
				else if(m==m_adsetting) // 상세 설정
					action.actionDetailSetting();
				
				
				
				
				else if(c.equals("자테온 포럼 방문하기")){
					if(Main.osname.startsWith("mac") || Main.osname.startsWith("win"))
						new WebBrowser(main, "http://jateon.kfmes.com");
					else
						new WebBrowser( true, "http://jateon.kfmes.com");
				}
					 //new WebBrowser(main, "http://jateon.kfmes.com");
				else if(c.equals("개발자 블로그 방문하기")){
					if(Main.osname.startsWith("mac") || Main.osname.startsWith("win"))
						new WebBrowser(main, "http://blog.kfmes.com");
					else
						new WebBrowser( true, "http://blog.kfmes.com");
				}
				else if(m==m_helpmenu) // 도움말
					if(Main.osname.startsWith("mac") || Main.osname.startsWith("win"))
						new WebBrowser(main, "http://jateon.kfmes.com/doc");
					else
						new WebBrowser( true, "http://jateon.kfmes.com/doc");
					//new WebBrowser(main, "http://blog.kfmes.com");
				else if(c.equals("라이센스"))
					action.actionAboutLicense();
				else if(c.equals("최신버전확인"))
					action.actionVersionCheck();
				else if(c.equals("JaTeOn 정보"))
					action.actionAbout();
					
		
				/*
				 * 이곳부터는 buddy 클릭했을때 나오는 메뉴에 대한 처리
				 * */
				else if(c.equals("쪽지 보내기(&Z)"))
					action.actionSendIMsg(null);
				else if(c.equals("대화 걸기(&A)"))
					action.actionReqChat(null);
				else if(c.equals("문자 보내기(&S)"))
					action.actionSendSMS();
				else if(c.equals("Debuging"))
					action.actionBuddyDbg();
				else if(c.equals("미니홈피방문")){
					action.actionVisitMiniHP((String) m.getData());
					//new WebBrowser("http://cyworld.com/pims/main/pims_main_nateon.asp?tid=" + m.getData());
				}
				else if(m==m_block)  // 차단 / 해제
					action.toggleBlock((NateFriend) m.getData());
				else if(m==m_removeBuddy)
					action.removeBuddy((NateFriend)m.getData());
					
				
				else if(m==m_GroupRename) // 그룹 이름 변경
					action.actionRenameGroup((NateGroup) m.getData());
				else if(m==m_GroupDelete) //그룹 지우기 
					action.actionDeleteGroup((NateGroup)m.getData());
				
				
				/*
				 * 이곳부터는 빈곳에서 팝업했을때 나오는 메뉴 처리
				 */
				
				else if(c.equals("이름으로 보기"))
					action.actionSetViewMode(0);
				else if(c.equals("대화명으로 보기"))
					action.actionSetViewMode(1);
				else if(c.equals("아이디로 보기"))
					action.actionSetViewMode(2);
				else if(c.equals("이름+아이디로 보기"))
					action.actionSetViewMode(3);
				else if(c.equals("이름+대화명으로 보기"))
					action.actionSetViewMode(4);
				else if(c.equals("오프라인 사용자 보기"))
					action.actionToggleOffView();
				
				else if(c.equals("목록 새로고침"))
					action.actionRefreshList();
				
				
				
			
			}
			else if (e.getSource() instanceof ToolItem) {
				ToolItem m = (ToolItem) e.getSource();
				//String c = m.getText();
				if(m==btn_Msg) //쪽지
					action.actionSendIMsg(null);
				else if(m==btn_Chat) //대화
					action.actionReqChat(null);
				else if(m==btn_SMS) // 문자
					action.actionSendSMS();
				else if(m==btn_addBuddy) // 친구추가
					action.actionAddFriend();
				else if(m==btn_addGroup)
					action.actionAddGroup();
				else if(m==btn_filemon)// 파일전송 모니터
					action.actionToggleFileMon();
				

			}
			
			
				
								
				
				
			
		}
		
		public void widgetDefaultSelected(SelectionEvent e) {}
		
		
	}






	

}
