/**
 * 
 */
package kfmes.jateon.swt.dialog;


import kfmes.jateon.swt.MainFrame;
import kfmes.natelib.NateonMessenger;

import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Button;

/**
 * 친구 추가 다이얼로그
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: AddFriendDialog.java,v 1.8 2007/11/19 10:13:30 kfmes Exp $
 */
public final class AddFriendDialog {

	private Shell sShell = null;  //  @jve:decl-index=0:visual-constraint="10,10"
	private Combo combo_glist = null;
	private NateonMessenger nate = null;
	private MainFrame frmmain = null;
	private Label label = null;
	private Label label1 = null;
	private Text txt_id = null;
	private Text txt_msg = null;
	private Button btn_ok = null;
	private Button btn_cancel = null;
	private Label label2 = null;
	//private MessageBox msgBox = new MessageBox(sShell, SWT.ICON_WARNING);

	/**
	 * This method initializes combo_glist	
	 *
	 */
	private void createCombo_glist() {
		GridData gridData3 = new GridData();
		gridData3.horizontalSpan = 2;
		combo_glist = new Combo(sShell, SWT.NONE | SWT.READ_ONLY);
		combo_glist.setLayoutData(gridData3);
		String foo = null;
		
		
		
		for(int i=0;i<nate.getBuddyGroup().count();i++){
			foo = nate.getBuddyGroup().get(i).getName();
			if(foo.equals("미분류"))
				continue;
			combo_glist.add(nate.getBuddyGroup().get(i).getName());

			if(foo.equals("기타"))
				combo_glist.select(i);
		}

		
		
		//combo_glist.select(combo_glist.getItemCount()-1);
	}
	/**
	 * dummy constructor
	 *
	 */
	public AddFriendDialog() {
	
	}
	public AddFriendDialog(NateonMessenger nate, MainFrame frmmain) {
		this.nate = nate;
		this.frmmain = frmmain;
		display();
	}
	private void display(){
		createSShell();
		sShell.open();

		while (!sShell.isDisposed()) {
			if (!Display.getCurrent().readAndDispatch())
				Display.getDefault().sleep();
		}
		sShell.dispose();
		
		
	}



	/**
	 * This method initializes sShell
	 */
	private void createSShell() {
		GridData gridData7 = new GridData();
		gridData7.horizontalAlignment = GridData.END;
		gridData7.verticalAlignment = GridData.CENTER;
		GridData gridData21 = new GridData();
		gridData21.horizontalAlignment = GridData.CENTER;
		gridData21.verticalAlignment = GridData.CENTER;
		GridData gridData11 = new GridData();
		gridData11.horizontalAlignment = GridData.CENTER;
		gridData11.verticalAlignment = GridData.CENTER;
		GridData gridData2 = new GridData();
		gridData2.horizontalAlignment = GridData.END;
		gridData2.grabExcessHorizontalSpace = true;
		gridData2.verticalAlignment = GridData.CENTER;
		GridData gridData1 = new GridData();
		gridData1.grabExcessHorizontalSpace = false;
		gridData1.verticalAlignment = GridData.CENTER;
		gridData1.horizontalSpan = 2;
		gridData1.horizontalAlignment = GridData.FILL;
		GridData gridData = new GridData();
		gridData.horizontalAlignment = GridData.FILL;
		gridData.grabExcessHorizontalSpace = true;
		gridData.grabExcessVerticalSpace = true;
		gridData.horizontalSpan = 2;
		gridData.verticalAlignment = GridData.FILL;
		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 3;
		sShell = new Shell(MainFrame.shell,  SWT.DIALOG_TRIM);
		sShell.setText("친구 추가");
		sShell.setLayout(gridLayout);
		label = new Label(sShell, SWT.NONE);
		label.setText("메일주소");
		txt_id = new Text(sShell, SWT.BORDER);
		txt_id.setLayoutData(gridData1);
		label1 = new Label(sShell, SWT.NONE);
		label1.setText(" 요청\n메시지");
		label1.setLayoutData(gridData11);
		txt_msg = new Text(sShell, SWT.MULTI | SWT.WRAP | SWT.V_SCROLL | SWT.BORDER);
		txt_msg.setText("친구 추가 합니당");
		txt_msg.setLayoutData(gridData);
		label2 = new Label(sShell, SWT.NONE);
		label2.setText("그룹");
		label2.setLayoutData(gridData21);
		createCombo_glist();
		
		sShell.setSize(new Point(290, 196));
		Label filler27 = new Label(sShell, SWT.NONE);
		btn_ok = new Button(sShell, SWT.NONE);
		btn_ok.setText("친구 요청");
		btn_ok.setLayoutData(gridData2);
		btn_ok.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				
				int atpos = txt_id.getText().indexOf("@");
				if(atpos<1){
					MessageBox msgBox= new MessageBox(sShell, SWT.ICON_WARNING);
					msgBox.setMessage("메일 주소 형식으로 넣어주세요");
					msgBox.open();
					txt_id.setFocus();
					return ;
				}
				
				int gid = Integer.parseInt(nate.getBuddyGroup().getGroup(
						combo_glist.getItem(combo_glist.getSelectionIndex())).getNumber());
				
				nate.getNS().requestAdd(txt_id.getText(), 
						txt_msg.getText().replaceAll("\n", "%0D%0A"),
						gid);
				sShell.dispose();
				
			}
		});
		btn_cancel = new Button(sShell, SWT.NONE);
		btn_cancel.setText("취    소");
		btn_cancel.setLayoutData(gridData7);
		btn_cancel.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				sShell.dispose();
			}
		});
	}

}
