/**
 * 
 */
package kfmes.jateon.swt.dialog;

import kfmes.jateon.swt.MainFrame;
import kfmes.natelib.NateonMessenger;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Display;

/**
 * 채팅 친구 초대 다이얼로그
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: ChatInviteDialog.java,v 1.3 2007/11/19 10:13:29 kfmes Exp $
 */
public class ChatInviteDialog {

	private Shell sShell = null;
	private Shell parentShell = null;
	private NateonMessenger nate;

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO 자동 생성된 메소드 스텁
		/* Before this is run, be sure to set up the launch configuration (Arguments->VM Arguments)
		 * for the correct SWT library path in order to run with the SWT dlls. 
		 * The dlls are located in the SWT plugin jar.  
		 * For example, on Windows the Eclipse SWT 3.1 plugin jar is:
		 *       installation_directory\plugins\org.eclipse.swt.win32_3.1.0.jar
		 */
		Display display = Display.getDefault();
		ChatInviteDialog thisClass = new ChatInviteDialog();
		thisClass.createSShell();
		thisClass.sShell.open();

		while (!thisClass.sShell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
		display.dispose();
	}
	
	// dummy constructor
	public ChatInviteDialog() {
	}
	
	public ChatInviteDialog(Shell parent, NateonMessenger nate){
		this.parentShell = parent;
		this.nate  = nate;
		
		Display display = Display.getDefault();
		createSShell();

		sShell.open();
		
		while (!sShell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
		sShell.dispose();
		
	}


	/**
	 * This method initializes sShell
	 */
	private void createSShell() {
		if(parentShell==null)
			sShell = new Shell(SWT.DIALOG_TRIM);
		else
			sShell = new Shell(parentShell, SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL);
			//(MainFrame.shell, SWT.DIALOG_TRIM);
		
		sShell.setText("친구 초대");
		
		
		
		sShell.setLayout(new GridLayout());
		sShell.setSize(new Point(400	, 300));
		sShell.setSize(400, 300);
	}

}
