/**
 * 
 */
package kfmes.natelib;



import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Hashtable;

import kfmes.natelib.entity.FriendList;
import kfmes.natelib.entity.GroupList;
import kfmes.natelib.entity.NateFriend;
import kfmes.natelib.entity.NateGroup;
import kfmes.natelib.entity.UserStatus;
import kfmes.natelib.ftp.FileRecver;
import kfmes.natelib.msg.InstanceMessage;
import kfmes.natelib.msg.Message;
import kfmes.natelib.util.MsgUtil;
import kfmes.natelib.util.PasswordEncryptor;

/**
 * NS 서버와의 메세지를 주고 받는 클래스
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: NotificationProcessor.java,v 1.118 2007/11/19 10:13:29 kfmes Exp $
 */
public class NotificationProcessor extends AbstractProcessor {
	

	protected String line = null;
		
	private final String DSserver = "203.226.253.91";
	
	private Message nmsg = new Message();
	public boolean isRunning = false;
	public boolean isFriendReady = false;
	public boolean isGroupReady = false;

	
	
	public HashMap<String,NateFriend> friendMap = null;
	private HashMap<String, NateFriend> friendMapUid = null;
	public FriendList friendlist = null;	
	public GroupList grouplist = null;
	public NateFriend tempFriend = null;
	//protected static int TrID = 1;
	private String MsgBuffer = null;
	
	private ArrayList<NateFriend> addME = new ArrayList<NateFriend>();
	protected Hashtable<String, String>tempStor = new Hashtable<String, String>();//임시적으로 보관할 용도로 사용
	
//	private Hashtable addBuddy = new Hashtable();
	private NateFriend tmpAddingFriend = null;

	private int tmpAddingGroupNum=0;
	
	private boolean readFlag = true;
	private int nextGLSTnum = 0;

	public int getTrid(){
		return TrID;
	}	
	
	public NotificationProcessor(NateonMessenger nate) {
		//MsgUtil.println("**NS.Constructor");
		this.nate = nate;
		super.setTrID(1);
		//this(nate,"", 5004, 0);
	}
	
	/*
	public NotificationProcessor(NateonMessenger nate, String Serveraddr) {
		this(nate,Serveraddr, 5004, 0);
	}
	
	public NotificationProcessor(NateonMessenger nate, String Serveraddr, int port) {
		this(nate,Serveraddr, port, 0);
	}
	
	public NotificationProcessor(NateonMessenger nate, String Serveraddr, int port, int TrID) {
		this.nate = nate;
		
	}
	*/
	public boolean Login(String loginName, String password){
		return this.Login(loginName, password, false);
		
	}
	/**
	 * 로그인을 한다.
	 * 
	 * @param loginName
	 * @param password
	 * @param encoded
	 */
	public boolean Login(String loginName, String password, boolean encoded){
		//MsgUtil.println("**NS.loginl");
		this.TrID = 1;
		try {
			String Enpass = null;
			if(encoded)
				Enpass = password;
			else{
				if(loginName.endsWith("@nate.com"))
					Enpass = PasswordEncryptor.getMD5String(
						password.concat(PasswordEncryptor.getID(loginName)));
				else
					Enpass = PasswordEncryptor.getMD5String(
							password.concat(loginName));
					
			}
				//Enpass = PasswordEncryptor.encrypt(password);
			
			makeConnection(DSserver,5004);
			//makeConnection("203.226.253.73",80);
			
			sendMessage("PVER" ,"3.615 3.0");
			line = recv();
			
			sendMessage("AUTH" ,"DES");
			line = recv();
			
			sendMessage("REQS" ,"DES " + loginName);
			line = recv();
						
			
			nmsg.SetMessage( line, getTrid());
			
			{
				//String dpcaddr ;
				String tmparr[];
				int dpcport;
				tmparr = line.split(" ");
				server = tmparr[3];
				dpcport = Integer.parseInt(tmparr[4]);
			
			
			//MsgUtil.println( server +" " + dpcport);
			makeConnection(server, dpcport);
			}
			
			//sendMessage("LSIN", loginName + " " + Enpass +" TE3");
			//sendMessage("LSIN", "id@nate.com fasfasdfasdfa991139 MD5 3.615 UTF8");
			sendMessage("LSIN", loginName + " " + Enpass + " MD5 3.615 UTF8");
			line = recv(); // 사용자 정보읽어옴
			try{
				if(line.startsWith("301"))
					throw new Exception("로그인 실패");
				
				NateFriend owner = null;
				String lsin[];
				lsin = line.split(" ");
				
				//MsgUtil.prints(lsin);
				
				//owner = new NateFriend(loginName,lsin[4],lsin[3],lsin[5]);
				owner = new NateFriend(loginName, lsin[2], lsin[3], lsin[4], lsin[5]);
				nate.setTicket(lsin[7]);
				
		//		MsgUtil.println(">>" + loginName+ lsin[2]+ lsin[3]+ lsin[4]+ lsin[5]);
				
				owner.setStatus(nate.initStatus);
				nate.setOwner(owner);
				/*	
			}
			catch (ArrayIndexOutOfBoundsException e) {
				//e.printStackTrace();
				closeConnection();
				this.isRunning = false;
				this.interrupt();
				
				nate.fireLoginError("로그인 실패");				
				return false;*/
			}catch (Exception e) {
				this.interrupt();
				closeConnection();
				this.isRunning = false;
				//e.printStackTrace();
				nate.fireLoginError("로그인 실패");
				return false;
				
			}
			
			if(!NateonMessenger.isSMSmode){
				
				sendMessage("CONF", "276 0");
				line = recv(); // 
				
				// 사용자 목록을 요구한다.
				friendlist = new FriendList();
				friendMap = new HashMap<String,NateFriend>();
				friendMapUid = new HashMap<String, NateFriend>();
				
				flushInputStream();
			
				
				sendMessage("LIST", null);
				MsgUtil.println("**LIST**");
				
				while(!isFriendReady) {
					// 수동 동기화, 친구 목록을 다 받을 때 까지 대기
					line = readLine();
					
					try{
					if(line.startsWith("LIST " + (TrID-1)))
						procLIST(line);
					else
						isFriendReady = true;
						//MsgUtil.println(line);
					
					
					}catch (Exception e) {
						isFriendReady = true;
					}
				}
				//MsgUtil.println("Friend count : " + friendlist.count());
				
				// 그룹 목록을 요구 한다. 
				grouplist = new GroupList();
				
				sendMessage("GLST", "0");
				
				while(!isGroupReady) {
					// 수동 동기화, 그룹 목록을 다 받을 때 까지 대기
					line = readLine();
					//MsgUtil.println(line);
					
					if(line.startsWith("GLST ") && line.split(" ").length > 4)
						procGLST(line);
					else if(line.startsWith("INFY "))
						procINFY(line);
					/*
					else // 2007.11.07 added 
						break;
					*/
				}
				
				
				// 그룹 이름으로 오름차순 정
				grouplist.sortGroup();
				
	//			 TODO: 남은 NateFriend 목록에서 그룹에 속한 친구를 찾아서 옮겨주기
				// 이때 남은 친구는 어떤 그룹에도 속하지 않는 친구다.
				// 어느 그룹에도 속하지 않은 친구들을 '미분류' 그룹으로 몰아 넣기 ㅡ.,ㅡ;
				if(friendlist.count()>0)
					procLeftLIST();
				
			
				// friendlist에 남은 수를 표시 (정상처리라면 0 이어야 함)
				//MsgUtil.println("Friend left : " + friendlist.count());
				
				//grouplist.listNameNick();
				nate.fireLoginComplete();		
				nate.fireBuddyListInit(grouplist);
							
				// 로그인 과정 완료. 주변에 로그인 통보
				if(NateonMessenger.isOffLogin)
					nate.setMyStatus(UserStatus.Invisible);
				else
					setMyStatus(nate.initStatus);
			}
			else{
				nate.fireLoginComplete();
			}
			
			
		} catch (IOException e) {
			e.printStackTrace();
			nate.fireLoginError("error : Login");
			return false;
		}
		return true;
	}
	
	/**
	 * 서버에서 오는 LIST 명령의 처리
	 * @param line
	 * @throws IOException
	 */
	private void procLIST(String line) throws Exception {
		//	TODO: 사용자 객체에 목록을 구분해서 저장하기.
		String list[];
		list = line.split(" ");
		//list[8] = list[8].replace("%20"," ");
		if(list[4].equals("0011") || list[4].equals("0101"))			return;
		
		if(list[4].startsWith("1") || list[4].endsWith("1")) {
			
			
			tempFriend = new NateFriend(list[4], list[5], list[6], list[7], list[8], list[9], list[10], list[11], list[12], list[13], list[14], list[15], list[16], list[17]);
			friendlist.add(tempFriend);
			friendMap.put(tempFriend.getNateID(), tempFriend);
			friendMapUid.put(tempFriend.getUid(), tempFriend);
		}
		if(list[4].equals("0001") )
			addME.add(tempFriend);
		
		MsgUtil.println(friendlist.count() + "<<<" + line);
		
		if(Integer.parseInt(list[2])+1 == Integer.parseInt(list[3])) isFriendReady = true;
	}


	/**
	 * 서버에서 오는 GLST 명령의 처리
	 * @param line
	 * @throws IOException
	 */
	private void procGLST(String line) throws IOException {
		// TODO: 그룹 객체에 목록을 구분해서 저장하기.
		String list[];
		MsgUtil.println(line);
		list = line.split(" ");
		//MsgUtil.println(line);
		if(list.length > 7)
		{
			// 실제 그룹 목록일 경우
			grouplist.add(Integer.parseInt(list[5]) ,new NateGroup(list[4], list[5], list[6]));
		}
		else if(list.length > 6)
		{
			// 그룹 링크 일 경
			tempFriend = friendlist.find(list[5]);
			if (tempFriend != null) {
				grouplist.addFriend(Integer.parseInt(list[6]),tempFriend);
				friendlist.remove(tempFriend);
			}
		}
		if(Integer.parseInt(list[2])+1 == Integer.parseInt(list[3])) isGroupReady = true;
		
		//MsgUtil.println(grouplist.count() + "<<<" + line);		
	}
	
	private void procLeftLIST() {
		int newGroupNo = grouplist.length();
		grouplist.add(newGroupNo, new NateGroup("Y", String.valueOf(newGroupNo), "미분류"));
		for(;friendlist.count()>0;) {
			tempFriend = friendlist.popup();
			grouplist.addFriend(newGroupNo, tempFriend);
		}
				
	}
	
	
	
	/**
	 * 서버에서 오는  INFY 명령의 처리
	 * INFY : 로그인되어있는 친구리스트통보
	 * 
	 * @param line
	 * @throws IOException
	 */
	private void procINFY(String line) throws IOException {
		/*
<<<INFY 0 A@lycos.co.kr O 0 %00 1
<<<NTFY 0 B@nate.com A 0 %00 1
		 */
		String list[];
		list = line.split(" ");
		//MsgUtil.errPrintln("-_-??");
		NateFriend f = (NateFriend) friendMap.get(list[2]);
		
		friendlist.setFriendStatus(list[2], list[3], list[4], list[5], list[6]);
		
		if(isRunning){
			f.setStatus(list[3]);
			nate.fireBuddyModified(f);
		}
		
		
		//nate.fireBuddyModified();
		//MsgUtil.println("<<<"+line);
	}


	
	//INFY 0 id@nate.com O 0 %00 1
	/**
	 * 
	 * NTFY : 상태가 변경된 친구통보
	 * @throws IOException
	 */
	private void procNTFY(String line) throws IOException{

		boolean isBeforeOffline = false;
		
		String list[] = line.split(" ");
		NateFriend f = (NateFriend) friendMap.get(list[2]);
		
		if(f==null){
			MsgUtil.errPrintln("---------------------\n" +line + "\n---------------------------");
			return ;
		}
			
		
		if(f.getStatus().equals(UserStatus.Offline) || f.getStatus().equals(UserStatus.Invisible))
			isBeforeOffline = true;
		
		f.setStatus(list[3]);
		
		if(list[3].equals("O") && isBeforeOffline)
			nate.fireUserOnline(f);
		
		if(list[3].equals(UserStatus.Offline) || list[3].equals(UserStatus.Invisible))
			nate.fireUserOffline(f);
		nate.fireBuddyModified(f);
		
		// XXX: UPDATED 2007.04.18
		//nate.fireBuddyListModified();
			
		
		

		/*
		String beforeStatus = grouplist.getFriendStatus(list[2]);
		
		//if(beforeStatus==null)
		if(beforeStatus.equals(UserStatus.Offline) || 
				beforeStatus.equals(UserStatus.Invisible))
			isBeforeOffline = true;
					
		grouplist.setFriendStatus(list[2], list[3], list[4], list[5], list[6]);
		//MsgUtil.println("!@#" + f.getNameNick());
		
		
		if(list[3].equals("O") && isBeforeOffline)
			nate.fireUserOnline(f);
		
		if(list[3].equals(UserStatus.Offline) || list[3].equals(UserStatus.Invisible))
			nate.fireUserOffline(f);
				
		nate.fireBuddyListModified();
		*/
		
		
		
		/*
		 * 
<<<NTFY 0 id@nate.com A 0 %00 1
<<<NTFY 0 A@nate.com F 0 %00 1
<<<INFY 0 id@nate.com O 0 %00 1
		 */
		
		//NateFriend f = new NateFriend()
		
		
		
	}

	/**
	 * 서버에서 오는 CTOC 명령을 처리
	 * CTOC : 연결요청/재요청
	 * @param header
	 * @throws IOException
	 */
	private void procCTOC(String header) throws IOException{
		String info[] = header.split(" ");
		String ctoc[];
		
		int msgLength = Integer.parseInt(info[3]);

		ByteArrayOutputStream inbuf = new ByteArrayOutputStream();
		inbuf.reset();
		
		
		String foo = read(msgLength);
		
		MsgUtil.println("<<<CTOC:"+foo);

		ctoc = foo.split("\r\n");			
		
		
		
		if(ctoc[0].equals("IMSG")){//쪽지받음!
			
			InstanceMessage im = new InstanceMessage(foo);// @modified kfmes 
			/*
			
			String msg = "";
			for(int i=14;i<ctoc.length;i++)
				msg += ctoc[i] + "\r\n";
			
			
			
			NateFont font = 
				new NateFont(MsgUtil.getProperty(ctoc[9]),MsgUtil.getProperty(ctoc[10]),
						MsgUtil.getProperty(ctoc[11]),MsgUtil.getProperty(ctoc[12]));
			NateFriend sender = friendMap.get(MsgUtil.getProperty(ctoc[2]));
			if(sender==null)
				sender = new NateFriend(MsgUtil.getProperty(ctoc[2]));
			// grouplist.getFriend(MsgUtil.getProperty(ctoc[2]));
			 
			
			
			InstanceMessage imm = 
				new InstanceMessage(MsgUtil.getProperty(ctoc[2]),MsgUtil.getProperty(ctoc[3]),msg,font);
			
			//MsgUtil.println(sender.getFormattedBuddy());
			
			im.setFriend(sender);
			
			//TODO: 쪽지 보낸 사람들 설정해야 되는데, 
			// 친구리스트를 얻어올수 없으므로 일단은  로그인 id로 전송
			*/
			NateFriend sender = friendMap.get(info[2]);
			if(sender==null)
				sender = new NateFriend(info[2]);
			im.setFriend(sender);
			
			
			nate.fireInstanceMessageReceived(im);
			return;
			
		}
		else if(ctoc[0].startsWith("INVT")) //채팅요청받음
		{
			String list[] = ctoc[0].split(" ");
			SwitchBoardSession ss = new SwitchBoardSession(nate,list[2],Integer.parseInt(list[3]), list[4]);
			nate.sessionList.add(ss);
			
			nate.fireSwitchboardSessionStarted(ss);
						
		}
		else if(ctoc[0].startsWith("REQC") ){//파일이닷
			NateFriend ref = grouplist.getFriend(info[2]);
			//REQC RES 192.168.0.3:5004 1037613324:14489
			String ll[]  = ctoc[0].split("[ :]");
			
			if(ll[1].equals("NEW")){
				nate.filemgr.setSendFileNew(ref, ll);

			}
			else if(ll[1].equals("RES")){
				//R(NateFriend recv, String host, int port, String cookie
				String host = ll[2];
				int port = Integer.parseInt(ll[3]);
				
				String cookie = ll[4] + ":" + ll[5];
				
				//MsgUtil.prints(ll);
				//int key = Integer.parseInt(ll[5]);
				
				//nate.filemgr.getRecvFile("d" +key).setRecv(ll);
				
				//TODO: 직접 서버가 될 수없는경우 FR서버를 요청해야함
				//boolean isDirect = true
				boolean isDirect = ! nate.filemgr.isForceUseFR();
				
				FileRecver recv = nate.filemgr.getFileRecver(cookie);
				recv.set(nate, ref, cookie);
				
				
				
				if(isDirect)
					nate.filemgr.startFileRecv(recv, true);
				else{
					//nate.filemgr.
					//recv.setFR();
					tempStor.put( getTrid()+"",foo);
					send("REFR", nate.getOwner().getNateID());
					
				}
				
			}
			else if(ll[1].equals("FR")){

				nate.filemgr.setSendFileFR(ref, ll);;
			}
			//NateFile f = nate.filemgr.getFile(Integer.parseInt(ll[5]));
			
			
		}
				/*
				
				//;// INVT id@nate.com 211.234.239.196 5004 774058CC2E0C38771063006103AC))
		else // 쪽지나 대화가 아닐경우 출력
			MsgUtil.println("========================\n" + foo + "\n=====================");
		*/

	}
	
	/**
	 * FR 서버를 사용한다고 한 뒤에 들어오는 response
	 * @param line
	 */
/*
REFR 133 211.234.239.175 5004 841114845
 */
	
	private void procREFR(String line){
		String ll[] = line.split(" ");
		String tmpStr = tempStor.get(ll[1]);
		if(tmpStr==null) // 정보가 없을경우 뭔가 잘못된것이니 무시
			return;
		String ctoc[] = tmpStr.split("[ \n\r]");
		MsgUtil.prints(ctoc);
		
		FileRecver recv =nate.filemgr.getFileRecver(ctoc[3]);
		recv.setFR(ll[4]);
				
		recv.setNetwork(ll[2], Integer.parseInt(ll[3]));
		
		nate.filemgr.startFileRecv(recv, false);
		
		//recv.set(nate, nate.filemgr, friendMap.get(key), cookie, port)
		
		
		//REQC RES 124.136.183.44:5004 10014827278:13306
		//send("REFR", ctoc[2]);
		
		//nate.filemgr.getFileRecver(cookie)
		
		
		
	}
	

	private void procNNIK(String line) {
		String list[] = line.split(" ");
		
		NateFriend f = (NateFriend) friendMap.get(list[2]);
		if(f==null)
			f= tmpAddingFriend;
		
		f.setNickName(list[3]);
		nate.fireBuddyListModified();
		
	}

	private void procRMVB(String line) {
		String list[] = line.split(" ");
		
		//grouplist.add(index, group)
		
		//NateFriend f = (NateFriend) friendMap.get(list[2]);
		//grouplist.setFriendStatus(list[2], list[3], list[4], list[5], list[6]);
		//MsgUtil.println("!@#" + f.getNameNick());
		
		// TODO 자동 생성된 메소드 스텁
		
	}

	private void procADDB(String line) {
		String list[] = line.split(" ");
		boolean whoaddme = false;
	//!ADDB 0 RL 10008531257 A@nate.com  - 추가
		//0    1 2   3                          4                                     5
	//ADDB 0 RL 1015000981 B@dreamwiz.com 덜덜덜덜%0D%0A덜덜 - 추가요청띄워야함
		
		if(list.length==3)
		{
			NateFriend f = friendMapUid.get(list[2]);
			nate.fireBuddyModified(f);
			return ;
		}
		NateFriend f = friendMap.get(list[4]);
		//if(f==null){
		
		
		if(list.length>5){
			whoaddme = true;
			f = new NateFriend(list[4]);
			
			
			f.setTag(list[5].replaceAll("%0D%0A", "\n").replaceAll("%20", " "));
						
		}
		
		f.setUid(list[3]);
		f.setNickName(f.getRealName());
		f.setFABR(true , "R");
		
		tmpAddingFriend =f ;
		nate.fireBuddyListModified();
		if(whoaddme){
			grouplist.get(grouplist.count()-1).addList(f);
			nate.fireWhoAddme(f);
		}
				
	}
	
	private void procNPRF(String line){
// 0			1 	2							3			4					5		6			7	  8
// !NPRF 0 A@nate.com 11111 0168404238 %00 29625330 %00 N		
//LIST 4 5 6 1101 id@nate.com 100254215 김가현 [가현]%20개강 0164108421 %00 19841020 15000981 1 1 %00 %00 N
		String list[] = line.split(" ");
		NateFriend f = friendMap.get(list[2]);
		if(f==null){
			f = new NateFriend(list[2]);
			
		}
		f.setPhoneNumber(list[4]);
		
	}
	
	
	private void procADSB(String line){
		String list[] = line.split(" ");
		// 0        1		2			3					4			5
		//ADSB 17 REQST 10008531257 김경욱 447
		//NateFriend nb = grouplist.getFriendUid(list[3]);
		
		
		NateFriend f=null;// = (NateFriend)addBuddy.get(list[1]);
		
		if(f==null)
			f = tmpAddingFriend;
		else{
			if(list[2].equals("REJCT"))
				return ;
			
			f.setUid(list[3]);
			f.setRealName(list[4]);
			
			
			grouplist.getGroup(tmpAddingGroupNum).addList(f);
			
			//grouplist.get(grouplist.count()-1).addList(f);
			
			friendMap.put(f.getID(),f );
			
			nate.fireBuddyListModified();
			//addBuddy.remove(f);
			
		}
		
		
	}
	


	/**
	 * 채팅방 생성
	 * @param from
	 * @param to
	 */
	public SwitchBoardSession procOpenChat(String from, String to){
/*
RESS 1701 

RESS 1701 211.234.239.210 5004 630634BD36D96BD71DC9005B7F8B

CTOC 1702 asdf@nate.com A 74

INVT id@nate.com 211.234.239.210 5004 630634BD36D96BD71DC9005B7F8BPACK 1702

PING 0

PING 1703 
 */
	
		try{
			boolean is_success = false;
			sendMessage("RESS",	 null);
			long curtime =  System.currentTimeMillis()/1000;
			long timeout = curtime + 5;
			String msgAr[] =null;
			String line = "";
			String ctocMsg = null;
			
			while((System.currentTimeMillis()/1000)<timeout){
			//	this.sleep(50);
				if(MsgBuffer!=null){
					msgAr = MsgBuffer.split(" ");
					line = MsgBuffer;
					MsgBuffer = null;
					is_success = true;
					break;
				}
			}
			if(!is_success)
				throw new Exception("RESS TimeOut");
			/*
			else 
				MsgUtil.println("$$RESSOK");
			*/
			{
				
				ctocMsg = "INVT " + from ;//" " + line.substring(7);
				
				for(int i =2;i<msgAr.length;i++)
					ctocMsg += " " + msgAr[i];
				//MsgUtil.println("$$" + ctocMsg);
			sendCTOC(to, ctocMsg);
/*
>>>CTOC 16 id@nate.com N 73
INVT A@dreamwiz.com211.234.239.20750044FD02A1933F245F7392C005DD1EC
 */
			SwitchBoardSession ss = 
				new SwitchBoardSession(nate, msgAr[2], Integer.parseInt(msgAr[3]), msgAr[4]);
			
			
			//
			//ctocMsg = "REQC NEW";
			//String host = InetAddress.getLocalHost().getHostAddress();
			
		//	sendCTOC(to, data)
			nate.sessionList.add(ss);
				return ss;
			
			}
		}catch (Exception e) {
			e.printStackTrace(); 
		}
		
		return null;
	}
	
	
	
	

	/**
	 * RESS 명령이 왔을때 처리
	 * @param line
	 */
	private void procRESS(String line) {
		// TODO : RESS 메세지 받았을때
		String ress[] = line.split(" ");
		
	}


	/** 쪽지 보내기 
	 * @param msg
	 * @throws IOException
	 */
	public void sendIMessage(InstanceMessage msg) throws IOException {
		sendCTOC(msg.getRef(), msg.toString());//, msg.getLength());
		
	}
	
	/** CTOC 메세지를 전송할때 사용
	 * 
	 * @param ref
	 * @param data
	 * @throws IOException
	 */
	public void sendCTOC(String ref, String data) throws IOException {
		sendCTOC(ref, data, data.getBytes("UTF8").length);	
	}
	
	public void sendCTOC(String ref, String data, int length) throws IOException {
		
		String ws = "CTOC " + TrID  + " " + ref + " N " + length + "\r\n" + data;
		//MsgUtil
		MsgUtil.println(">>>" + ws);
		out.write(ws.getBytes("UTF8"));
		TrID++;
		//XXX: 주석처리
		//MsgUtil.print(">>>" + ws);
		
	}




	/**
	 * 자신의 상태를 변경한다.
	 * @param status
	 * @throws IOException
	 */
	public void setMyStatus(String status) throws IOException{
		sendMessage("ONST", status + " 0");
		nate.fireOwnerStatusUpdated();
		
	}
	
	/**
	 * 자기 닉네임을 변경
	 * @param newName
	 */
	public void setMyNickName(String newName) {
		//TODO: 나중에 닉넴 변경 실패라는 ....
		// 만들어줄 필요있을려나-_-
		
	
		try{
		sendMessage("CNIK", newName);
		}catch (IOException e) {
			MsgUtil.println("닉네임 변경실패");
			e.printStackTrace();
		}
		nate.fireOwnerStatusUpdated();
		
	}
	public void renameGroup(NateGroup group,  String newname){
		try{
			send("RENG",nextGLSTnum++ + " " + group.getNumber() + " " + MsgUtil.getEncString(newname));
			group.setName(newname);
			nate.fireBuddyListModified();
		}catch (IOException e) {

		}
		
	}
	/**
	 * 그룹을 삭제한다
	 * 해당 그룹에 buddy 가 존재할경우 <b>아마도 지워지지 않을것이다</b>
	 * @param group
	 */
	public void removeGroup(NateGroup group){
/*
		RMVG 459 6 1
		RMVG 459 7
		*/
		try{
			send("RMVG" , nextGLSTnum++ + " " + group.getNumber());
			grouplist.remove(group);
			nate.fireBuddyListModified();
		}catch (Exception e) {
			
		}


	}
	

	public void moveGroup(NateFriend friend, String number, String newg) {
		String data = "0 " + friend.getUid() + " " + friend.getID() +" " + number + " " + newg; 
		try {
			send("MVBG", nextGLSTnum++ +" " + (data.length()+2) // \r\n
					+ "\n" +	data);
			friend.getGroup().removeList(friend);
			grouplist.getGroup(Integer.parseInt(newg)).addList(friend);
			
			nate.fireBuddyListModified();
		} catch (IOException e) {
			// TODO 자동 생성된 catch 블록
			e.printStackTrace();
		}
		
		
		
	}

	public ArrayList getNewAddList(){
		return this.addME;
	}
	
	public void requestAdd(String id, String msg) {
		requestAdd(id, msg, 0);
	}
	
	public void requestAdd(String id, String msg, int groupnum) {
	//		ADSB 17 REQST %00 A@nate.com 0 안녕하세요.%0D%0A당신을%20네이트온%20친구로%20요청합니다.
			//ADSB 158 REQST %00 B@dreamwiz.com 100004 hello%20wolrd%0D%0Aasdsa
			// TODO 자동 생성된 메소드 스텁
			try{
				sendMessage("ADSB", "REQST %00 " + id +" " + groupnum+ " " + msg);
	//			grouplist.addFriend(0, friend);
			}catch (Exception e) {
				e.printStackTrace();
			}
		
			//NateFriend nb = new NateFriend(id);
			tmpAddingFriend = new NateFriend(id);
			tmpAddingFriend.setFABR("1100");
			tmpAddingGroupNum = groupnum;
			
			//System.out.println(getTrid()-1+"");
			
			//addBuddy
			//addBuddy.put((this.getTrid()-1) + "", nb);
			
			/*
			try{
				String line = readLine();
				String list[] = line.split(" ");
				// 0        1		2			3					4			5
				//ADSB 17 REQST 10008531257 김경욱 447
				NateFriend nb = new NateFriend(id,list[4],list[4]);
				nb.setFABR("1100");
				nb.setUid(list[3]);
				
				nate.fireBuddyListModified();
			}catch (Exception e) {
				e.printStackTrace();
			}
			*/
		}

	public void addGroup(String name){
		try{
			
			send("ADDG", (nextGLSTnum++) + " " + MsgUtil.getEncString(name));
			
			tempStor.put("ADDG", name);
			
		}catch (Exception e) {
			// TODO: handle exception
		}
	}

	private void procADDG(String line){
		String ll[] = line.split(" ");
		String name = tempStor.remove("ADDG");
				
		readFlag = true;
		grouplist.add(Integer.parseInt(ll[3]), new NateGroup("Y", ll[3], name));
		grouplist.sortGroup();
		//nate.fireBuddyListInit(grouplist);
		nate.fireBuddyListModified();
	}

	public void sendADSB(boolean isAccept, NateFriend friend) {
		/*
>>ADSB 148 ACCPT 1015000981 A@dreamwiz.com 0
         0   1    2 	 		3					4 
<<ADSB 148 ACCPT 1015000981 김가현 481
		 */
		String accpet = (isAccept) ? "ACCPT" : "REJCT";
		try{
			sendMessage("ADSB", accpet + " " + friend.getUid() + " " + friend.getID() + " 0" );
			/*
			line = readLine();
			String list[] = line.split(" ");
			friend.setRealName(list[4]);
			*/
			
		}catch (Exception e) {
			e.printStackTrace();
		}
		
		
	}

	/**
	 * 친구 차단 / 해제 
	 * @param fr
	 * @param block
	 */
	public void sendBlock(NateFriend fr, boolean block) {
		char fabr[] = fr.getFABR().toCharArray();
		//boolean block = fabr[2] =='1' ? true : false;
		fabr[2] = block ? '1' : '0';
		
		
		fr.setFABR(new String(fabr));
		//MsgUtil.println("CHANGE : " + fr.getFABR());
		String addb = block ? "BL" : "AL";
				
		try {
			send("ADDB", addb + " " + fr.getUid() + " " + fr.getNateID());
			
		} catch (IOException e) {
			e.printStackTrace();
		}
						
		
	}
	
	public void removeBuddy(NateFriend friend){
		//RMVB 573 FL 1015000981 A@dreamwiz.com 0
		try {
			send("RMVB", "FL " + friend.getUid() + " " + friend.getID() + " 0");
			friendMap.remove(friend.getID());
			friendlist.remove(friend);
			
			nate.fireBuddyListModified();
		}catch (Exception e) {
			e.printStackTrace();
		}
		
	}

	public void run() {
		
		isRunning = true;
		
		while( in!=null && isRunning || this.isConnected()){
			try{
				
				if(addME.size()>0){
					//requestAdd(((NateFriend)addME.get(0)).getID(), "네이트온 친구 요청" );
					nate.fireWhoAddme(addME.get(0));
					addME.remove(0);
				}
				
				//if(line==null || line.equals(""))
				if(readFlag)
					line = readLine();
				else 
					line = null;
				
				/*
				if(line ==null){
					sleep(10);
					continue;
				}*/
				
				//line = "";
				if(line!=null){
					MsgUtil.println("<<<" + line);
					if(line.equals("null"))
						break;
					else if(line.startsWith("PING "))
						sendMessage("PING", null);
					else if(line.startsWith("CTOC 0"))
						procCTOC(line);
					else if(line.startsWith("REFR"))
						procREFR(line);
					else if(line.startsWith("RESS"))
						MsgBuffer = line;
					else if(line.startsWith("NTFY "))
						procNTFY(line);
					else if(line.startsWith("LIST ")){
						//MsgUtil.errPrintln("-_-)//");
						procLIST(line);
						nate.fireBuddyListModified();
					}
					else if(line.startsWith("INFY "))
						procINFY(line);
						
					
					else if(line.startsWith("ADDB")){
						procADDB(line);
					}
					else if(line.startsWith("ADSB")){
						procADSB(line);
					}
					else if(line.startsWith("RMVB"))
						procRMVB(line);
					
					else if(line.startsWith("NNIK"))
						procNNIK(line);
					
					else if(line.startsWith("NPRF"))
						procNPRF(line);
					else if(line.startsWith("ADDG"))
						procADDG(line);
					
					else if(line.startsWith("KILL")){
						nate.logout();
						nate.fireKilled();
						
						isRunning = false;
						//nate.logout();
						
											
					}
					
				}
					
				}catch (Exception e) {
					e.printStackTrace();
					
				}
				
			}
		
		closeConnection();
		
		MsgUtil.println("종료됨 : " + this.toString());
	}
	



}