package kfmes.natelib.entity;

/**
 * 
 * @author bronks, kfmes
 * @version $Id: NateGroup.java,v 1.16 2007/11/19 10:13:33 kfmes Exp $
 */

import java.util.ArrayList;

public class NateGroup {

	private String visual = null;
	private String groupNumber = null;
	private String groupName = null;
	private FriendList list = null;
	
	public NateGroup(String view, String number, String name){
		this.visual = view;
		this.groupNumber = number;
		this.groupName = name;
		list = new FriendList();
	}
	
	public String getVisual() {
		return this.visual;
	}
	
	public String getNumber() {
		return this.groupNumber;
	}
	
	public String getName(){
		return this.groupName.replaceAll("%20", " ").replaceAll("%25", "%");
	}
	
	public void addList(NateFriend friend) {
		if(list.isNew(friend))
			list.add(friend);
		friend.setGroup(this);
	}
	
	public void removeList(NateFriend friend) {
		list.remove(friend);
		friend.setGroup(null);
		
	}
	
	public void listNameId() {
		// 주석처리 kfmes
		//MsgUtil.println(this.groupName);
		list.listNameID();
	}
	
	public void listNameNick() {
		// kfmes
		//MsgUtil.println(this.groupName);
		list.listNameNick();
	}
	
	public ArrayList<NateFriend> getList(){
		return this.list.getFriendList();
	}
	
	public FriendList get()
	{
		return list;
	}
	
	@Override
	public String toString() {

		return this.groupName;
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {

	}

	public void setName(String newname) {
		this.groupName = newname;
		
	}

}