/**
 * 
 */
package kfmes.natelib.util;

import java.io.IOException;
import java.net.InetAddress;
//import java.net.NetworkInterface;
import java.util.ArrayList;
import java.util.Enumeration;

/**
 * 로컬호스트의 아이피를 찾는 클래스
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: LocalHostLookup.java,v 1.8 2007/11/19 10:13:37 kfmes Exp $
 */
public final class LocalHostLookup {
	public static ArrayList getLocalhost() throws IOException{
		ArrayList<String> list = new ArrayList<String>();
		

	//try{			
		//Class cl = Class.forName("java.net.NetworkInterface");
		
		Enumeration<java.net.NetworkInterface> nics = java.net.NetworkInterface.getNetworkInterfaces();
		
		//Method m = cl.getClass().getMethod("getNetworkInterfaces", new Class);
		
		
		//Enumeration nics = cl.getMethod(name, parameterTypes).getNetworkInterfaces();
		
		while(nics.hasMoreElements()){
			
			java.net.NetworkInterface nic = nics.nextElement();
			
			if(! (nic.getName().startsWith("e") || nic.getName().startsWith("w")))
				continue;
			if(nic.getDisplayName().startsWith("VM"))
				continue;
			
			//if(!(nic.getName().startsWith("eth") ||  nic.getName().startsWith("w") || )  
					//|| nic.getDisplayName().startsWith("VM") )
			
				//continue;
			//System.out.println("--" + nic.getName() + "---" + nic.getDisplayName());
			Enumeration<InetAddress>addr = nic.getInetAddresses();
			
			while(addr.hasMoreElements()){
				InetAddress inet = addr.nextElement();
				if(inet.getHostAddress().indexOf(":")>0)
					continue;
				if(inet.isSiteLocalAddress())
					list.add(inet.getHostAddress());
				
			}
			
		}

	
		/*
		}catch (NoClassDefFoundError e) {
			MsgUtil.errPrintln(e.getMessage());
			list.add("127.0.0.1");
			
		} 
		/*catch (ClassNotFoundException e) {
			MsgUtil.errPrintln(e.getMessage());
			list.add("127.0.0.1");		
		}*/
		if(list.size()==0)
			list.add("127.0.0.1");
		return list;
	}
}
