/**
 * 
 */
package kfmes.natelib.util;

import java.io.InputStream;
import java.io.PrintStream;

import kfmes.natelib.NateonMessenger;

/**
 * 메세지 처리를 하는데 빈번하게 사용될법한 
 * method들을 모아놓은 클래스
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: MsgUtil.java,v 1.11 2007/11/19 10:13:37 kfmes Exp $
 */
public class MsgUtil {
	public static InputStream in = System.in;
	public static PrintStream out = System.out;
	public static PrintStream err =System.err;
	
	public static String getProperty(String message){
		return message.substring(message.indexOf(":")+1);
	}
	
	public static void println(String message){
		if(NateonMessenger.isDebugMode)
			System.out.println(message);
	}
	public static void print(String message){
		if(NateonMessenger.isDebugMode)
			System.out.print(message);
	}
	
	public static void prints(String message[]){
		if(NateonMessenger.isDebugMode)
			System.out.println("-------------------------");
			for(int i=0;i<message.length;i++)
				System.out.println("msg " + i + " : " + message[i]);
			System.out.println("-------------------------");
	}

	public static void errPrintln(String string) {
		System.err.println(string);
		
	}
	public static String getRealString(String string){
		return string.replaceAll("%20", " ")
							.replaceAll("%25", "%")
							.replaceAll("%00", "")
							.replaceAll("%09", "\t")
							;
	}

	public static String getEncString(String string) {
		return string.replaceAll(" ", "%20").replaceAll(" ", "%25");
	}
	
	

}
