/**
 * 
 */
package kfmes.jateon.swt.dialog;

import kfmes.jateon.swt.MainFrame;
import kfmes.jateon.swt.UIToolKit;
import kfmes.natelib.NateonMessenger;
import kfmes.natelib.entity.NateFriend;
import kfmes.natelib.msg.InstanceMessage;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.KeyListener;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

/**
 * 보내는 쪽지 다이얼로그
 * @author kfmes(KIM Ga-Hyeon, jateon@kfmes.com, http://jateon.kfmes.com )
 * @version $Id: SendMessage.java,v 1.11 2007/11/19 10:13:30 kfmes Exp $
 */
final public class SendMessage {
	

	private Shell sShell = null;  //  @jve:decl-index=0:visual-constraint="10,10"
	private Label lbl_sender = null;
	private Label lbl_recver = null;
	private StyledText txt_areas = null;
	private Text txt_area = null;
	private Button btn_reply = null;
	private Button btn_dispose = null;
	
	private Listener listener = new Listener();
	private NateonMessenger nate = null;
	private NateFriend recvUser = null;


	/**
	 * This method initializes sShell
	 */
	private void createSShell() {
		GridData gridData4 = new GridData();
		gridData4.horizontalAlignment = GridData.FILL;
		gridData4.grabExcessHorizontalSpace = true;
		gridData4.grabExcessVerticalSpace = true;
		gridData4.horizontalSpan = 2;
		gridData4.verticalAlignment = GridData.FILL;
		GridData gridData3 = new GridData();
		gridData3.horizontalAlignment = GridData.END;
		gridData3.grabExcessHorizontalSpace = true;
		gridData3.verticalAlignment = GridData.CENTER;
		GridData gridData2 = new GridData();
		gridData2.horizontalAlignment = GridData.CENTER;
		gridData2.verticalAlignment = GridData.CENTER;
		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 2;
		GridData gridData1 = new GridData();
		gridData1.horizontalAlignment = GridData.FILL;
		gridData1.grabExcessHorizontalSpace = true;
		gridData1.horizontalSpan = 2;
		gridData1.verticalAlignment = GridData.CENTER;
		GridData gridData = new GridData();
		gridData.grabExcessHorizontalSpace = true;
		gridData.verticalAlignment = GridData.CENTER;
		gridData.horizontalSpan = 2;
		gridData.horizontalAlignment = GridData.FILL;
		sShell = new Shell(/*MainFrame.shell,*/
				SWT.TITLE | SWT.RESIZE | SWT.MODELESS | SWT.MIN | SWT.MAX);//MainFrame.shell )// , 
				/*SWT.MODELESS  | SWT.RESIZE | SWT.MAX );*/
		
		sShell.setText("보내는 쪽지");
		sShell.setImage(UIToolKit.DefaultImage);
		sShell.setLayout(gridLayout);
		sShell.setSize(new Point(320, 220));

		lbl_recver = new Label(sShell, SWT.NONE);
		lbl_recver.setText("");
		lbl_recver.setLayoutData(gridData);
		
		lbl_sender = new Label(sShell, SWT.NONE);
		lbl_sender.setText("보내는이 : " + nate.getOwner().getRealName());
		lbl_sender.setLayoutData(gridData1);

		if(MainFrame.useStyledText()){
			txt_areas = new StyledText(sShell, SWT.MULTI | SWT.WRAP | SWT.V_SCROLL | SWT.BORDER);
			txt_areas.setLayoutData(gridData4);
			txt_areas.addKeyListener(listener);
		}else{
			txt_area =  new Text(sShell, SWT.MULTI | SWT.WRAP | SWT.V_SCROLL | SWT.BORDER);
			txt_area.setLayoutData(gridData4);
			txt_area.addKeyListener(listener);
		}
		btn_reply = new Button(sShell, SWT.NONE);
		btn_reply.setText(" 보내기 ");
		btn_reply.setLayoutData(gridData3);
		
		btn_dispose = new Button(sShell, SWT.NONE);
		btn_dispose.setText(" 닫  기 ");
		btn_dispose.setLayoutData(gridData2);
		
		btn_reply.addSelectionListener(listener);
		btn_dispose.addSelectionListener(listener);

		
	}
	
	private void Send() {
		//msg = new InstanceMessage(
		//owner.getNateID(),recvUser.getNateID(), txtMessage.getText());
		try{
			if(MainFrame.useStyledText()){
				nate.sendIMessage(new InstanceMessage(
						nate.getOwner().getNateID(), recvUser.getNateID(), txt_areas.getText()));
			}else{
				nate.sendIMessage(new InstanceMessage(
						nate.getOwner().getNateID(), recvUser.getNateID(), txt_area.getText()));
			}
			
		}catch (Exception e) {
			e.printStackTrace();
		}
		this.sShell.dispose();
	}
	/*
	public RecvMessage(NateonMessenger nate, InstanceMessage imsg){
		this.nate = nate;
		this.imsg = imsg;
		createSShell();
		set();
		while(!this.sShell.isDisposed()){
			if(!Display.getCurrent().readAndDispatch())
				Display.getCurrent().sleep();
		}
		sShell.dispose();
	}
	 */
	public SendMessage(MainFrame main, NateonMessenger nate, NateFriend recvUser) {
		//this.frmMsgDialog.setLocationByPlatform(true);
		this.nate = nate;
		createSShell();
		main.addWindow(sShell);
		this.recvUser = recvUser;
		this.lbl_recver.setText("받는이 : " + recvUser.getNameID());
		this.sShell.setVisible(true);
		this.sShell.setFocus();
		
		while(!this.sShell.isDisposed()){
			if(!Display.getCurrent().readAndDispatch())
				Display.getCurrent().sleep();
		}
		main.removeWindow(sShell);
		sShell.dispose();
	}
	public SendMessage(MainFrame main, NateonMessenger nate, InstanceMessage msg, RecvMessage RM) {
		this.nate = nate;
		
		createSShell();
		main.addWindow(sShell);
		//this.txt_area.setText(msg.getMessage());
		this.lbl_recver.setText(msg.getRef());
		this.recvUser = msg.getFriend();
		
		this.sShell.setVisible(true);
		this.sShell.setFocus();
		
		if(RM!=null){
			main.removeWindow(RM.sShell);
			RM.dispose();
		}
		
	
		while(!this.sShell.isDisposed()){
			if(!Display.getCurrent().readAndDispatch())
				Display.getCurrent().sleep();
		}
		main.removeWindow(sShell);
		sShell.dispose();
	}

	
	private class Listener implements SelectionListener, KeyListener{
		public void widgetDefaultSelected(SelectionEvent e) {}
		public void widgetSelected(SelectionEvent e) {

			if(e.getSource()==btn_dispose)
				sShell.dispose();
			else if(e.getSource()==btn_reply)
				Send();
			
				
			
		}
		public void keyPressed(KeyEvent e) {

			if((e.stateMask == SWT.CTRL && e.keyCode==SWT.CR) ||
					(e.stateMask == SWT.ALT && (e.character=='s'|| e.character=='S'))					
					)
				Send();
			
			
			else if(e.keyCode == SWT.ESC)
				sShell.dispose();
		
		}
		public void keyReleased(KeyEvent e) {
			// TODO 자동 생성된 메소드 스텁
			
		}
		
	}

}
